function proydH = proyection( dH )
%PROYECTION compute the difference between a matrix and its mean along time dimensin  
%
%	Copyright (C) 2016 Santiago Sanz Estbanez <ssanest@lpi.tel.uva.es>
%	Laboratorio de Procesado de Imagen, Universidad de Valladolid
%	www.lpi.tel.uva.es
%
%   When indicated, some parts are based on code from Lucilio Cordero Grande:
%       https://kclpure.kcl.ac.uk/portal/en/persons/lucilio-corderogrande.html
%
%   This program is free software: you can redistribute it and/or modify
%   it under the terms of the GNU General Public License as published by
%   the Free Software Foundation, either version 3 of the License, or
%   (at your option) any later version.
%
%   This program is distributed in the hope that it will be useful,
%   but WITHOUT ANY WARRANTY; without even the implied warranty of
%   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
%   GNU General Public License for more details.
%
%   You should have received a copy of the GNU General Public License
%   along with this program.  If not, see <http://www.gnu.org/licenses/>.
%Input
%dH: array to proyect 
%
%Output
%proydH: proyection over the mean
 

%proyectio for gradient descent method
tam=size(dH);
if ndims(dH)==2
    %traslational y rigid 
    N=tam(1);
    proydH=(dH-ones(N,1)*mean(dH,1))';
elseif ndims(dH)==4
    %bspline (repmat)
    N=tam(3);
    proydH=dH-repmat(mean(dH,3),[1 1 N 1]);
end
end

